Bug 825161 - False positive unusedStructMember when using C++ templates
False positive unusedStructMember when using C++ templates
Status: CLOSED WORKSFORME
Product: Fedora
Classification: Fedora
Component: cppcheck (Show other bugs)
19
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Susi Lehtola
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-05-25 05:26 EDT by Slawomir Czarko
Modified: 2014-12-22 18:46 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-12-22 18:46:18 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
File which triggers the error (222 bytes, text/x-c++src)
2012-05-25 05:26 EDT, Slawomir Czarko
no flags Details

  None (edit)
Description Slawomir Czarko 2012-05-25 05:26:42 EDT
Created attachment 586810 [details]
File which triggers the error

Description of problem:

When running cppcheck on code using C++ templates sometimes I get false positive unusedStructMember.


Version-Release number of selected component (if applicable):
1.53-1.fc15
1.54-1.fc15 (SRPM from Fedora 16 recompiled on Fedora 15)

How reproducible:
100%

Steps to Reproduce:
1. cppcheck --quiet --enable=all cppcheck.cpp
2.
3.
  
Actual results:
[cppcheck.cpp:8]: (style) struct or union member 'B::y' is never used


Expected results:
No problems reported

Additional info:

If I rename B::y to B::x then the error disappears. If I then change f() so it doesn't use a.x I get the error back, this time for both structures:
[cppcheck.cpp:3]: (style) struct or union member 'A::x' is never used
[cppcheck.cpp:8]: (style) struct or union member 'B::x' is never used
Comment 1 Fedora End Of Life 2012-08-07 12:42:06 EDT
This message is a notice that Fedora 15 is now at end of life. Fedora
has stopped maintaining and issuing updates for Fedora 15. It is
Fedora's policy to close all bug reports from releases that are no
longer maintained. At this time, all open bugs with a Fedora 'version'
of '15' have been closed as WONTFIX.

(Please note: Our normal process is to give advanced warning of this
occurring, but we forgot to do that. A thousand apologies.)

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, feel free to reopen
this bug and simply change the 'version' to a later Fedora version.

Bug Reporter: Thank you for reporting this issue and we are sorry that
we were unable to fix it before Fedora 15 reached end of life. If you
would still like to see this bug fixed and are able to reproduce it
against a later version of Fedora, you are encouraged to click on
"Clone This Bug" (top right of this page) and open it against that
version of Fedora.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.

The process we are following is described here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 2 Susi Lehtola 2012-08-07 15:35:44 EDT
Whoops, this seems to have passed me by. Looks like the issue is still present in 1.55. Reporting upstream.
Comment 3 Fedora End Of Life 2013-04-03 15:45:04 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19
Comment 4 Susi Lehtola 2014-12-22 18:46:18 EST
Looks like this has slipped under my radar. Anyway, it is working at least in cppcheck 1.67.

Note You need to log in before you can comment on or make changes to this bug.